/* draw_vports.c */

#include "head_usycams.h"
#include "def_usycams.h"
#include "objects.h"

float p2, p4, p8, p35, p37, p38, p41, p79;

draw_vp0()
{
 float vert1[2], vert2[2];

 vert1[0]=(XMAX0)*scala; vert1[1]=0;
 vert2[0]=vert1[0];      vert2[1]=(YMAX2-YMAX0)*scala;

 screen_vp0();
 fminit();
 c3f(lblack);
 clear();
 
 if(POS6) c3f(green); else c3f(red);
 bgnline();
  v2f(vert1);
  v2f(vert2);
 endline();
 exitscreenmode();
}

draw_vp2()
{
 float vert1[2], vert2[2];

 p2=20.*scala; p4=40.*scala; p8=80.*scala; p35=35*scala; p37=37.*scala;
 p38=38.*scala; p41=41*scala, p79=79*scala;
 vert1[0]=(XMAX0)*scala; vert1[1]=0;
 vert2[0]=(XMAX1)*scala; vert2[1]=0;

 screen_vp2();
 fminit();
 c3f(lblack);
 clear();

 pushmatrix();
  translate(0.,(ysize-YMAX2*scala)/2.,0.);
   /*------------------------- BEGIN POS0 ------------------- */
   pushmatrix();
    translate(45*scala,0.,0.);
    if(POS0) 
     { 
      c3f(green);
      pushmatrix();
       scale(scala,scala,1.); 
       callobj(ARROWF);
      popmatrix();
     } 
    else 
     {
      c3f(red);
      pushmatrix();
       scale(scala,scala,1.); 
       callobj(ARROW);
      popmatrix();
     }
    c3f(yellow);
    rect(-p35,-p37,p35,p37);
   popmatrix();
   /*------------------------- END POS0   ------------------- */

   /*------------------------- BEGIN POS1 ------------------- */
   pushmatrix();
    translate(132*scala,0.,0.);
    if(LIN3)
     { 
      c3f(green);
      pushmatrix();
       scale(scala,scala,1.); 
       callobj(LINKS3F);
      popmatrix();
     } 
    else 
     {
      c3f(red);
      pushmatrix();
       scale(scala,scala,1.); 
       callobj(LINKS3);
      popmatrix();
     }
    c3f(yellow);
    rect(-p4,-p37,p4,p37);
   popmatrix();
   pushmatrix();
    translate(211*scala,0.,0.);
    if(!LIN3)
     { 
      c3f(green);
      pushmatrix();
       scale(scala,scala,1.); 
       callobj(LINKS4F);
      popmatrix();
     } 
    else 
     {
      c3f(red);
      pushmatrix();
       scale(scala,scala,1.); 
       callobj(LINKS4);
      popmatrix();
     }
    c3f(yellow);
    rect(-p4,-p37,p4,p37);
   popmatrix();
   /*------------------------- END POS1   ------------------- */

   /*------------------------- BEGIN POS2 ------------------- */
   pushmatrix();
    translate(300*scala,0.,0.);
    if(!IND) 
     {
      c3f(green); 
      pushmatrix();
       scale(scala, scala, 0.);
       callobj(OSCILLATINGF);
      popmatrix();
     }
    else
     {
      c3f(red);
      pushmatrix();
       scale(scala, scala, 0.);
       callobj(OSCILLATING);
      popmatrix();
     }
    c3f(yellow);
    rect(-p4,-p37,p4,p37);
   popmatrix();
   pushmatrix();
    translate(379*scala,0.,0.);
    if(IND) 
     {
      c3f(green); 
      pushmatrix();
       scale(scala, scala, 0.);
       callobj(INDEXINGF);
      popmatrix();
     }
    else
     {
      c3f(red);
      pushmatrix();
       scale(scala, scala, 0.);
       callobj(INDEXING);
      popmatrix();
     }
    c3f(yellow);
    rect(-p4,-p37,p4,p37);
   popmatrix();
   /*------------------------- END POS2   ------------------- */

   /*------------------------- BEGIN POS3 ------------------- */
   pushmatrix();
    translate(447*scala,0.,0.);
    c3f(yellow);
    rect(-p38/2.,-p37,p38/2.,p37);
    scale(scala,scala,1.);
    callobj(I);
   popmatrix();
   pushmatrix();
    translate(507*scala,0.,0.);
    if(REVI)
     {
      c3f(green);
      pushmatrix();
       translate(-9*scala,-13*scala,0.);
       scale(scala, scala, 0.);
       callobj(REVOLUTEF);
      popmatrix();
     }
    else
     {
      c3f(red);
      pushmatrix();
       translate(-9*scala,-13*scala,0.);
       scale(scala, scala, 0.);
       callobj(REVOLUTE);
      popmatrix();
     }
    c3f(yellow);
    rect(-p41,-p37,p41,p37);
   popmatrix();
   pushmatrix();
    translate(588*scala,0.,0.);
    if(!REVI)
     {
      c3f(green);
      pushmatrix();
       translate(29*scala,-26*scala,0.);
       rotate(1376,'z');
       scale(scala, scala, 0.);
       callobj(PRISMATICF);
      popmatrix();
     }
    else
     {
      c3f(red);
      pushmatrix();
       translate(29*scala,-26*scala,0.);
       rotate(1376,'z');
       scale(scala, scala, 0.);
       callobj(PRISMATIC);
      popmatrix();
     }
    c3f(yellow);
    rect(-p41,-p37,p41,p37);
   popmatrix();
   /*------------------------- END POS3   ------------------- */

   /*------------------------- BEGIN POS4 ------------------- */
   pushmatrix();
    translate(657*scala,0.,0.);
    c3f(yellow);
    rect(-p38/2.,-p37,p38/2.,p37);
    scale(scala*0.5,scala,1.);
    callobj(O);
   popmatrix();
   pushmatrix();
    translate(717*scala,0.,0.);
    if(REVO)
     {
      c3f(green);
      pushmatrix();
       translate(-9*scala,-13*scala,0.);
       scale(scala, scala, 0.);
       callobj(REVOLUTEF);
      popmatrix();
     }
    else
     {
      c3f(red);
      pushmatrix();
       translate(-9*scala,-13*scala,0.);
       scale(scala, scala, 0.);
       callobj(REVOLUTE);
      popmatrix();
     }
    c3f(yellow);
    rect(-p41,-p37,p41,p37);
   popmatrix();
   pushmatrix();
    translate(798*scala,0.,0.);
    if(!REVO) 
     {
      c3f(green);
      pushmatrix();
       translate(29*scala,-26*scala,0.);
       rotate(1376,'z');
       scale(scala, scala, 0.);
       callobj(PRISMATICF);
      popmatrix();
     }
    else
     {
      c3f(red);
      pushmatrix();
       translate(29*scala,-26*scala,0.);
       rotate(1376,'z');
       scale(scala, scala, 0.);
       callobj(PRISMATIC);
      popmatrix();
     }
    c3f(yellow);
    rect(-p41,-p37,p41,p37);
   popmatrix();
   /*------------------------- END POS4   ------------------- */

   /*------------------------- BEGIN POS5 ------------------- */
   pushmatrix();
    translate(927*scala,0.,0.);
    c3f(yellow);
    rect(-p79,-p37,p79,p37);
    scale(scala,scala,1.);
    callobj(MESH);
    if(POS5)  c3f(green); else c3f(red);
/*pushmatrix();*/
rotate(100,'z');
scale(140,50,1.);
callobj(SPL2);

/*popmatrix();
    callobj(CURV);*/
   popmatrix();
   /*------------------------- END POS5     ------------------- */

   /*------------------------- BEGIN POS6   ------------------- */
   pushmatrix();
    translate(1053*scala,0.,0.);
    c3f(green);
    if(POS6) 
     {
      pushmatrix();
       rotate(-900,'z');
       scale(scala,scala,1.); 
       callobj(ARROWF);
      popmatrix();
     }
    else 
     {
      c3f(red);
      pushmatrix();
       rotate(-900,'z');
       scale(scala,scala,1.); 
       callobj(ARROW);
      popmatrix();
     }
/*    rectf(-p35,-p37,p35,p37);*/
    c3f(yellow);
    rect(-p35,-p37,p35,p37);
   popmatrix();   
   /*------------------------- END POS6     ------------------- */
 popmatrix();

 if(POS6) c3f(green); else c3f(red);
 bgnline();
  v2f(vert1);
  v2f(vert2);
 endline();
 exitscreenmode();
}

