/* main_usycams.c */

#include "head_usycams.h"
#include "def_usycams.h"
#include "attrib_usycams.h"
#include "objects.h"
/*#include "def_surfaces.h"*/

#define LEFTANDMIDDLEMOUSE 444

 long xsize, ysize;
 long xorg = 0.;
 long yorg = 0.0;
 Angle azim = 0;
 Angle elev = 0;
 float dist = 20.;
 Angle twist = 0;
 float xorig = 0.;
 float yorig = 0.;
 float zorig = 0.;
 float param = 1.0;
 float scala;
 double vp3_var[8]={1.,4*PI/6,1.,0.,.1,0.07,.07,.2};
                   /*D1A A1D D3D A3D D4D A4D LLE LRI*/
 double vp4_var[8]={2.0944,4,.2,.4,0.1,8.,2*PI*.7,0.};
                            /*DPH PHM PS1 PS2 PS3 STP x-per*/
 double io[200][5];
 double slide34[300];

 Boolean LIN3, IND, REVI, REVO;
 Boolean CCW,NOR,CWR,D1D,A1D,D4D,A4D,D3D,A3D,LRI,LLE;
 Boolean DPH,PHM,PS1,PS2,PS3,STP;
 Boolean DI_3_OSC,DI_3_IND,DI_4,INDM,OSCM;
 int indexing, points,psii[500],phii[500],velz,counter,mech_id;
 double k1=-.07,k2=.01;

double sc[6*POINTS+M][2][3],sf[6*POINTS+M][2][3]; 
double uc[6*POINTS+M][CPOINTS+1][3],uf[6*POINTS+M][CPOINTS+1][3]; 
double v_cam[6*POINTS+M][CPOINTS+1][3];
double v_fol[6*POINTS+M][CPOINTS+1][3];
float  nsc[6*POINTS+M][2][3],nsf[POINTS+M][2][3];
float  nuc[6*POINTS+M][CPOINTS+1][3],nuf[6*POINTS+M][CPOINTS+1][3];
float  nvc[6*POINTS+M][CPOINTS+1][3],nvf[6*POINTS+M][CPOINTS+1][3];


main()
{
 int disp_prog[1], rise[1], retu[1];
 short val;
 FILE *fp;

 POS0 = LIN3 = IND = REVI = REVO = TRUE; 
 DI_3_IND=NOR=TRUE;
 indexing = 3;
 velz=counter=0;
 rise[0]=retu[0]=2;
 /* fp=fopen("usycams.dat","w");*/

 foreground();
 initialize();
 setscreen();

 backface(1);
 use_light_calc();

 draw_icons_vp2();
 draw_icons_vp3();
 draw_icons_vp4();
 draw_i_vp3_vp4();
 while(1)
  {
    resize(rise,retu);
    NOR=TRUE; CCW=CWR=FALSE; velz=0;
    vp2(disp_prog, rise, retu);
    POS0=FALSE;
    draw_icons_vp4();
    select_vp1(disp_prog, rise, retu);
  }
 /* fclose(fp);*/
}

initialize()
{
 keepaspect(XMAXSCREEN, YMAXSCREEN);
 winopen("USYCAMS");
 qdevice(LEFTMOUSE);
 qdevice(MIDDLEMOUSE);
 qdevice(RIGHTMOUSE);
 RGBmode();
 doublebuffer(); 
 gconfig();
 zbuffer(TRUE); 
 zclear();
 mmode(MVIEWING);
 loadmatrix(idmat);
 translate(-xorg, -yorg, -dist);
 rotate(elev, 'x');
 rotate(-azim, 'z'); 
 def_light_calc();
 use_light_calc();
 subpixel(TRUE);
}

setscreen()
{
 getorigin(&xorg, &yorg);
 getsize(&xsize, &ysize);
 scala = (float)(xsize)/(float)(XMAXSCREEN);

 viewport((int)(XMAX0*scala), (int)(XMAX1*scala), (int)(YMAX0*scala), 
	(int)(YMAX2*scala));
 lsetdepth(0,0x7f0000);
 lRGBrange(0,10,10,  0,255,255,  0,0x7f0000); 
}

init_vp1(rise,retu)
int rise[1],retu[1];
{
  int mousex, mousey;
  long delx, dely;
  short val;

  resize(rise,retu);
  mousex = getvaluator(MOUSEX);
  mousey = getvaluator(MOUSEY);
       /* check if mouse is inside of window; if not skip everything*/
  if((mousex>=xorg) && (mousex <= xorg+xsize) &&
     (mousey >= yorg) && (mousey <= yorg+ysize))
    {		            
      mousex = mousex - xorg;	      /* convert mousex,y into screen crdts */
      mousey = mousey - yorg;

      if(qtest()==LEFTMOUSE && mousex<(int)(82.*scala) 
	 && mousex>(int)(10.*scala) && mousey>(int)((YMAX2+10)*scala))
	{  
	  qread(&val); 
	  qread(&val);
	  POS0=TRUE;
	}
      if(mousex <= (int)(XMAX1*scala) &&  mousex>(int)(XMAX0*scala) &&
	 mousey<(int)(YMAX2*scala))
	{
	  if(mousey> (int)(YMAX0*scala))
	    {
	      if(mousemove(&delx, &dely, LEFTMOUSE)) 
		{
		  azim = mod360(azim + (Angle)2*delx);
		  elev = mod360(elev - (Angle)2*dely);
		  /*twist = mod360(twist + (Angle)2*dely);*/
		}
	      if(mousemove(&delx, &dely, MIDDLEMOUSE)) 
		{
		  xorig= xorig - .008*delx;
		  yorig= yorig - .008*dely;
		}
	      if(mousemove(&delx, &dely, LEFTANDMIDDLEMOUSE)) 
		param = param - .004*dely;
	    }
	  else if(mousey < (int)((YMAX0-10)*scala) &&
		  D1D || A1D || D4D || A4D || D3D || A3D ||
		  LRI || LLE || DPH || PHM || PS1 || PS2 ||PS3 || STP &&
		  mousex>40.*scala && mousex<1058*scala)
	    {
	      if(mousemove(&delx, &dely, LEFTMOUSE))
		update_var(delx);
	    }
	}
      if(qtest()==LEFTMOUSE && mousex>(int)((XMAX1+10)*scala))
	check_icons(mousex,mousey);
      qreset();
    }
}

typedef struct {
	long lastx;
	long lasty;
	} Lastpos;

static Lastpos lastleft = {-1, -1};
static Lastpos lastmid = {-1, -1};
static Lastpos lastleftmid = {-1, -1};

int mousemove(long *delx, long *dely, int buttname)
{
 long mousex, mousey;
 Lastpos *lastmouse;
 Boolean buttpress;

 if (buttname == LEFTMOUSE) {
	lastmouse = &lastleft;
	buttpress = (getbutton(LEFTMOUSE) && !getbutton(MIDDLEMOUSE));
 }

 else if (buttname == MIDDLEMOUSE) {
	lastmouse = &lastmid;
	buttpress = (!getbutton(LEFTMOUSE) && getbutton(MIDDLEMOUSE));
 }


 else if (buttname == LEFTANDMIDDLEMOUSE) {
	lastmouse = &lastleftmid;
	buttpress = (getbutton(LEFTMOUSE) && getbutton(MIDDLEMOUSE));
 }

 if (buttpress) {
	mousex = getvaluator(MOUSEX);
	mousey = getvaluator(MOUSEY);
	if (lastmouse->lastx > 0 ) {
		*delx = mousex - lastmouse->lastx;
		*dely = mousey - lastmouse->lasty;
	}
	else {
		*delx = 0;
		*dely = 0;
	}
	lastmouse->lastx = mousex;
	lastmouse->lasty = mousey;
	return 1;
 }
 else {
	lastmouse->lastx = -1;
	lastmouse->lasty = -1;
	return 0;
 }
}

mod360 (int angle)
{
 if (angle > 1800) return (angle - 3600);
 else if (angle < -1800) return (angle + 3600);
 else return(angle);
}

resize(rise,retu)
int rise[1],retu[1];
{
 short val;

 if(qtest()== REDRAW)
   { 
     qread(&val);
     setscreen(); 
     draw_i_vp3_vp4();
     draw_vp0();
     draw_vp2();
     draw_vp3();
     draw_vp4(rise,retu);
     draw_vp5();
qreset();
   }
 else if(qtest()==INPUTCHANGE) 
   {
     qread(&val);
qreset();
   }
}

ioanim()
{
  int i;
  points = (int)(POINTS/vp4_var[3]);

  for(i=0;i<=points+1;i++)
    {
      if(i<=POINTS)
	{
	  psii[i]=(int)(io[i][0]*1800/PI);
	  phii[i]=(int)(io[i][1]*1800/PI);
	}
      else
	{
	  psii[i]=2*psii[i-1]-psii[i-2];
	  phii[i]=(int)(phii[0]);
	}
    }
}

ioanim_osc()
{
  int i;
  points = (int)(POINTS);

  for(i=0;i<=points+1;i++)
    {
	  psii[i]=(int)(io[i][0]*1800/PI);
	  phii[i]=(int)(io[i][1]*1800/PI);
    }
}

animate(rise,retu)
int rise[1],retu[1];
{
  mmode(MVIEWING);
  perspective(400,(1280/1024.), 0.01, 100.0);
  
  loadmatrix(idmat);

  c3f(black);
  clear();
  zclear();

  translate(-xorig, -yorig,-dist);
  rotate(elev, 'x');
  rotate(azim, 'y');
  scale(param, param, param);
  poly_mode();
  /*backface(1);*/
  draw_solids();

  depthcue(0);
  backface(0);lmbind(LMODEL,1);

  draw_vp5();
  draw_vp0();
  draw_vp2();
  draw_vp3();
  draw_vp4(rise,retu);
  swapbuffers();
}
