/* cs_3_osc_rp.c */

#include "head_usycams.h"
#include "def_usycams.h"
#include "objects.h"
#include "def_surfaces.h"

/*
double sc[6*POINTS+M][2][3],sf[6*POINTS+M][2][3]; 
double uc[6*POINTS+M][CPOINTS+1][3],uf[6*POINTS+M][CPOINTS+1][3]; 
double v_cam[6*POINTS+M][CPOINTS+1][3];
double v_fol[6*POINTS+M][CPOINTS+1][3];
float  nsc[6*POINTS+M][2][3],nsf[POINTS+M][2][3];
float  nuc[6*POINTS+M][CPOINTS+1][3],nuf[6*POINTS+M][CPOINTS+1][3];
float  nvc[6*POINTS+M][CPOINTS+1][3],nvf[6*POINTS+M][CPOINTS+1][3];
*/
cs_3_osc_rp(alp1,l)
double alp1,l[2];
{
 double z3,dz3,psi;
 int i,j,n;

 alp1=-alp1;
 for(i=0;i<=POINTS;i++)
  {
    psi= io[i][0];
    z3 = io[i][1];
    dz3= io[i][2];
    for(j=0;j<2;j++)
      { 
	sc[i][j][0] = -dz3*sin(alp1)*cos(psi)-z3*sin(alp1)*sin(psi);
	sc[i][j][1] = dz3*sin(alp1)*sin(psi)-z3*sin(alp1)*cos(psi);
	sc[i][j][2] = l[j];
	nsc[i][j][0]= sin(psi);
	nsc[i][j][1]= cos(psi);
	nsc[i][j][2]=0;
      }
    uc[i][0][0]  = 0;
    uc[i][0][1]  = 0;
    uc[i][0][2]  = l[0];
    uc[i][1][0]  = sc[i][0][0];
    uc[i][1][1]  = sc[i][0][1];
    uc[i][1][2]  = l[0];
    for(j=0;j<2;j++)
      {
    	nuc[i][j][0] = 0;
    	nuc[i][j][1] = 0;
    	nuc[i][j][2] = -1;
      }
    v_cam[i][0][0]  = 0;
    v_cam[i][0][1]  = 0;
    v_cam[i][0][2]  = l[1];
    v_cam[i][1][0]  = sc[i][1][0];
    v_cam[i][1][1]  = sc[i][1][1];
    v_cam[i][1][2]  = l[1];
    for(j=0;j<2;j++)
      {
    	nvc[i][j][0] = 0;
    	nvc[i][j][1] = 0;
    	nvc[i][j][2] = 1;
      }
  }
 draw_cam2();
 draw_fol2(1.,2.*vp4_var[1]+vp4_var[0]+vp3_var[7]-vp3_var[6],vp3_var[7]-vp3_var[6]);
}


draw_cam2()
{
 double v1[3],v2[3];
 float  n1[3],n2[3];
 int    i,j,k;


 makeobj(CAM);
	   lmbind(MATERIAL,C_CAM); /* steel */
   for (k=0; k<1; k++)
     {
      bgnqstrip();
      for (i=0; i<=POINTS; i++)      
       {
         for(j=0;j<3;j++)
           {
            v1[j]=sc[i][k][j];
            v2[j]=sc[i][k+1][j];
            n1[j]= nsc[i][k][j];
            n2[j]= nsc[i][k+1][j];
           }
         n3f(n2);
         v3d(v2);
         n3f(n1);
         v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<1;k++)
     {
      bgnqstrip();
      for(i=POINTS;i>=0;i--)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = uc[i][k][j];
           v2[j] = uc[i][k+1][j];
           n1[j] = nuc[i][k][j];
           n2[j] = nuc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<1;k++)
     {
      bgnqstrip();
      for(i=0;i<=POINTS;i++)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = v_cam[i][k][j];
           v2[j] = v_cam[i][k+1][j];
           n1[j] = nvc[i][k][j];
           n2[j] = nvc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }
 closeobj();
}

draw_fol2(lm,h,th)
double lm,h,th;
{
 double r,c;

 c = lm/th;
 r = th*c;
 makeobj(FOL);
           lmbind(MATERIAL,C_FOL);
  pushmatrix();
   rotate(-900+(int)(vp3_var[1]*1800/PI),'x');
   pushmatrix();
     translate(0.,0.,-th/2.);
     cylindf(r,.25*th,1.);
     translate(0.,0.,.25*th);
     draw_cone(r,.75*th,-53.13*PI/180.,3);
  popmatrix();
  popmatrix();
  translate(0.,0.,-.4*th);
  cylindf(2*th/6.,h,1.);
  translate(0.,0.,h);
  draw_cone(2*th/6.,th/20.,-45*PI/180.,3);
 closeobj();
}
