/* draw_icons_vp2.c */

#include "head_usycams.h"
#include "objects.h"
#include "def_usycams.h"

float spline[19][2]={
  {0.,0.},
  {0.027778,0.000141},
  {0.055556,0.001121},
  {0.083333,0.003756},
  {0.111111,0.008808},
  {0.138889,0.016969},
  {0.166667,0.028834},
  {0.194444,0.044888},
  {0.222222,0.065485},
  {0.250000,0.090845},
  {0.277778,0.121041},
  {0.305556,0.155999},
  {0.333333,0.195501},
  {0.361111,0.239191},
  {0.388889,0.286586},
  {0.416667,0.337089},
  {0.444444,0.390010},
  {0.472222,0.444585},
  {0.500000,0.500000}
};

float curva[2][2]={
  {-70.,-30.},
  {70.,30.}
};

float arrow1[9][2]={
  {10.,-10.},
  {30.,10.},
  {10.,30.},
  {10.,18.},
  {-28.,18.},
  {-28.,-29.},
  {-11.,-29.},
  {-11.,2.},
  {10.,2.}
};

float arrow2[7][2]={
  {11.,7.},
  {31.,15.},
  {11.,23.},
  {11.,17.},
  {-32.,17.},
  {-32.,13.},
  {11.,13.}
};

float arrow3[7][2]={
  {12.,-8.},
  {32.,0.},
  {12.,8.},
  {12.,2.},
  {0.,2.},
  {0.,-2.},
  {12.,-2.}
};

float revol[4][2]={
  {9.,-5.},
  {41.,-5.},
  {41.,5.},
  {9.,5.}
};

float prisma1[12][2]={
  {0.,-4.},
  {19.,-4},
  {19.,-14.},
  {63.,-14.},
  {63.,-11.},
  {26.,-11.},
  {26.,11.},
  {63.,11.},
  {63.,14.},
  {19.,14},
  {19,4.,},
  {0.,4.}
};

float prisma2[4][2]={
  {34.,-10.},
  {43.,-10.},
  {43.,10.},
  {34.,10.}
};

float prisma3[4][2]={
  {56.,3.},
  {63.,3.},
  {63.,11.},
  {56.,11.}
};

draw_icons_vp2()
{
 int i;

 float v1[2], v2[2], v3[2], v4[2], v5[2], v6[2], v7[2], v8[2], v9[2], v10[2];

 makeobj(ARROWF);
  bgnpolygon();
   for(i=0;i<3;i++)
     v2f(arrow1[i]);
  endpolygon();
  rectf(-28.,2.,10.,18);
  rectf(-28.,-29.,-11.,2.);
 closeobj();

 makeobj(ARROW);
  bgnclosedline();
   for(i=0;i<9;i++)
     v2f(arrow1[i]);
  endclosedline();
 closeobj();

 makeobj(LINKS3F);
  pushmatrix();
   translate(0.,-4.,0.);
   for(i=0;i<3;i++)
     {
      rotate(1200,'z');
      arc(0.,0.,26.,-70,674);
      circf(0.,24.,10.);
     }
  popmatrix();
 closeobj();

 makeobj(LINKS3);
  pushmatrix();
   translate(0.,-4.,0.);
   for(i=0;i<3;i++)
     {
      rotate(1200,'z');
      arc(0.,0.,26.,-70,674);
      circ(0.,24.,10.);
     }
  popmatrix();
 closeobj();
 
 makeobj(LINKS4F);
  pushmatrix();
   for(i=0;i<4;i++)
     {
      rotate(900,'z');
      arc(0.,0.,28.,-241,241);
      circf(18.,18.,10.);
     }
  popmatrix();
 closeobj();

 makeobj(LINKS4);
  pushmatrix();
   for(i=0;i<4;i++)
     {
      rotate(900,'z');
      arc(0.,0.,28.,-241,241);
      circ(18.,18.,10.);
     }
  popmatrix();
 closeobj();

 makeobj(OSCILLATINGF);
  bgnpolygon();
   for(i=3;i<7;i++)
     v2f(arrow2[i]);
  endpolygon();
  bgnpolygon();
     v2f(arrow2[0]);
     v2f(arrow2[1]);
     v2f(arrow2[2]);
  endpolygon();
  pushmatrix();
   rotate(1800,'z');
   bgnpolygon();
    for(i=3;i<7;i++)
      v2f(arrow2[i]);
   endpolygon();
   bgnpolygon();
      v2f(arrow2[0]);
      v2f(arrow2[1]);
      v2f(arrow2[2]);
   endpolygon();  
  popmatrix();
 closeobj();

 makeobj(OSCILLATING);
  bgnclosedline();
   for(i=0;i<7;i++)
     v2f(arrow2[i]);
  endclosedline();
  pushmatrix();
   rotate(1800,'z');
   bgnclosedline();
    for(i=0;i<7;i++)
      v2f(arrow2[i]);
   endclosedline();
  popmatrix();
 closeobj();

 makeobj(INDEXINGF);
  bgnpolygon();
   for(i=3;i<7;i++)
     v2f(arrow3[i]);
  endpolygon();
  bgnpolygon();
     v2f(arrow3[0]);
     v2f(arrow3[1]);
     v2f(arrow3[2]);
  endpolygon();
  pushmatrix();
   translate(-32.,0.,0.);
   bgnpolygon();
    for(i=3;i<7;i++)
      v2f(arrow3[i]);
   endpolygon();
   bgnpolygon();
      v2f(arrow3[0]);
      v2f(arrow3[1]);
      v2f(arrow3[2]);
   endpolygon();  
  popmatrix();
 closeobj();

 makeobj(INDEXING);
  bgnclosedline();
   for(i=0;i<7;i++)
     v2f(arrow3[i]);
  endclosedline();
  pushmatrix();
   translate(-32.,0.,0.);
   bgnclosedline();
    for(i=0;i<7;i++)
      v2f(arrow3[i]);
   endclosedline();
  popmatrix();
 closeobj();

 makeobj(REVOLUTEF);
  c3f(green);
  rectf(9.,-5.,41.,5.);
  circf(0.,0.,10.);
  pushmatrix();
   rotate(1197,'z');
   rectf(9.,-5.,41.,5.);
  popmatrix();
  c3f(lblack);
  circ(0.,0.,4.);
  circ(0.,0.,7.);  
  pushmatrix();
   rotate(1197,'z');
   arc(0.,0.,10.,-300,300);
  popmatrix();
 closeobj();

 makeobj(REVOLUTE);
  bgnline();
   for(i=0;i<4;i++)
     v2f(revol[i]);
  endline();
  circ(0.,0.,4.);
  circ(0.,0.,7.);
  arc(0.,0.,10.,300,3300);
  pushmatrix();
   rotate(1197,'z');
   bgnline();
    for(i=0;i<4;i++)
      v2f(revol[i]);
   endline();
  popmatrix();
 closeobj();

 v1[0]=43.; v1[1]=-3.; v2[0]=43.; v2[1]=3.;
 v3[0]=56.; v3[1]=11.; v4[0]=63.; v4[1]=11.;
 v5[0]=56.; v5[1]=5.; v6[0]=63.; v6[1]=5.;
 v7[0]=56.; v7[1]=-5.; v8[0]=63.; v8[1]=-5.;
 v9[0]=56.; v9[1]=-11.; v10[0]=63.; v10[1]= -11.;

 makeobj(PRISMATICF);
  c3f(green);
  rectf(0.,-4.,19.,4.);
  rectf(19.,-14.,26.,14.);
  rectf(26.,-14.,63.,-11.);
  rectf(26.,11.,63.,14.);
  rectf(34.,-9.,43.,9.);
  rectf(56.,3.,63.,11.);
  rectf(56.,-11.,63.,-3.);
  rectf(43.,-3.,82.,3.);
  c3f(lblack);
  bgnline();
   v3f(v1);
   v3f(v2);
  endline();
  bgnline();
   v3f(v3);
   v3f(v4);
  endline();
  bgnline();
   v3f(v5);
   v3f(v6);
  endline();
  bgnline();
   v3f(v7);
   v3f(v8);
  endline();
  bgnline();
   v3f(v9);
   v3f(v10);
  endline();
 closeobj();

 makeobj(PRISMATIC);
  bgnclosedline();
   for(i=0;i<12;i++)
      v2f(prisma1[i]);
  endclosedline();
  rect(34.,-10.,43.,10.);
  rect(56.,3.,63.,11.);
  rect(56.,-11.,63.,-3.);
  rect(43.,-3.,82.,3.);
 closeobj();

 makeobj(I);
  rectf(-.5,-17.,.5,17.);
  rectf(-4.,16.5,4.,17.5);
  rectf(-4.,-17.5,4.,-16.5);
 closeobj();

 makeobj(O);
  circ(0.,0.,16.5);
  circ(0.,0.,17.);
  circ(0.,0.,17.5);
 closeobj();

 makeobj(MESH);
  v1[1]=-37.; v1[0]=0.; v2[1]=37.; v2[0]=0.;
  v3[0]=-79.; v3[1]=0.; v4[0]=79.; v4[1]=0.;
  c3f(yellow);
  pushmatrix();
   translate(0.,-24.,0.);
   for(i=0;i<5;i++)
     {
      bgnline();
       v2f(v3);
       v2f(v4);
      endline();
      translate(0.,12.,0.);
     }
  popmatrix();
  pushmatrix();
   translate(-72.,0.,0.);
   for(i=0;i<13;i++)
     {
      bgnline();
       v2f(v1);
       v2f(v2);
      endline();
      translate(12.,0.,0.);
     }
  popmatrix();
 closeobj();


 makeobj(CURV);
  bgnline();
  for(i=0;i<2;i++)
       v2f(curva[i]);
  endline();
 closeobj();

 makeobj(SSPL);
 pushmatrix();
 translate(-.5,-.5,0.);
 bgnline();
  for(i=0;i<19;i++)
       v2f(spline[i]);
 endline();
 popmatrix();
 closeobj();

 makeobj(SPLI);
  callobj(SSPL);
  pushmatrix();
   rotate(1800,'x');
   rotate(1800,'y');
   callobj(SSPL);
  popmatrix();
 closeobj();
 
 makeobj(SPL2);
  pushmatrix();
   translate(.5,.5,0.);
   callobj(SSPL);
  popmatrix();
  pushmatrix();
  rotate(1800,'z');
  pushmatrix();
   translate(.5,.5,0.);
   callobj(SSPL);
  popmatrix();
  popmatrix();
 closeobj();
}

