/* main_usycams.c */

#include "head_usycams.h"
#include "def_usycams.h"
/*#include "attrib_usycams.h"*/
/*#include "objects.h"*/
/*#include "def_surfaces.h"*/


update_var(delx)
int delx;
{
  switch(mech_id)
    {
    case three_osc_rr:
      if(D1D)  vp3_var[0] = vp3_var[0] + .004*(double)(delx);
      if(A1D)  vp3_var[1] = vp3_var[1] + .02*(double)(delx);
      if(D3D)  vp3_var[2] = vp3_var[2] + .004*(double)(delx);
      if(A3D)  vp3_var[3] = vp3_var[3] + .02*(double)(delx);
      if(D4D)  vp3_var[4] = vp3_var[4] + .004*(double)(delx);
      if(A4D)  vp3_var[5] = vp3_var[5] + .02*(double)(delx);
      if(LLE)  vp3_var[6] = vp3_var[6] + .008*(double)(delx);
      if(LRI)  vp3_var[7] = vp3_var[7] + .008*(double)(delx);
      if(DPH)  vp4_var[0] = vp4_var[0] + .008*(double)(delx);
      if(PHM)  vp4_var[1] = vp4_var[1] + .008*(double)(delx);
      if(PS1)  vp4_var[2] = vp4_var[2] + .008*(double)(delx);
      if(PS2)  vp4_var[3] = vp4_var[3] + .008*(double)(delx);
      if(PS3)  vp4_var[4] = vp4_var[4] + .008*(double)(delx);
      if(STP)  vp4_var[5] = vp4_var[5] + (delx)/8.;
      break;
    case three_osc_rp: 
      if(D1D)  vp3_var[0] = vp3_var[0] + .004*(double)(delx);
      if(A1D)  vp3_var[1] = vp3_var[1] + .02*(double)(delx);
      if(D3D)  vp3_var[2] = vp3_var[2] + .004*(double)(delx);
      if(A3D)  vp3_var[3] = vp3_var[3] + .02*(double)(delx);
      if(D4D)  vp3_var[4] = vp3_var[4] + .004*(double)(delx);
      if(A4D)  vp3_var[5] = vp3_var[5] + .02*(double)(delx);
      if(LLE)  vp3_var[6] = vp3_var[6] + .008*(double)(delx);
      if(LRI)  vp3_var[7] = vp3_var[7] + .008*(double)(delx);
      if(DPH)  vp4_var[0] = vp4_var[0] + .008*(double)(delx);
      if(PHM)  vp4_var[1] = vp4_var[1] + .008*(double)(delx);
      if(PS1)  vp4_var[2] = vp4_var[2] + .008*(double)(delx);
      if(PS2)  vp4_var[3] = vp4_var[3] + .008*(double)(delx);
      if(PS3)  vp4_var[4] = vp4_var[4] + .008*(double)(delx);
      break;
    case three_osc_pr:
      if(D1D)  vp3_var[0] = vp3_var[0] + .004*(double)(delx);
      if(A1D)  vp3_var[1] = vp3_var[1] + .02*(double)(delx);
/*      if(D3D)  vp3_var[2] = vp3_var[2] + .004*(double)(delx);
      if(A3D)  vp3_var[3] = vp3_var[3] + .02*(double)(delx);*/
      if(D4D)  vp3_var[4] = vp3_var[4] + .004*(double)(delx);
/*      if(A4D)  vp3_var[5] = vp3_var[5] + .02*(double)(delx);*/
      if(LLE)  vp3_var[6] = vp3_var[6] + .008*(double)(delx);
      if(LRI)  vp3_var[7] = vp3_var[7] + .008*(double)(delx);
      if(DPH)  vp4_var[0] = vp4_var[0] + .008*(double)(delx);
      if(PHM)  vp4_var[1] = vp4_var[1] + .008*(double)(delx);
      if(PS1)  vp4_var[2] = vp4_var[2] + .008*(double)(delx);
      if(PS2)  vp4_var[3] = vp4_var[3] + .008*(double)(delx);
      if(PS3)  vp4_var[4] = vp4_var[4] + .008*(double)(delx);
      break;
    case three_osc_pp:
      break;
    case three_ind_rr:
      if(D1D)  vp3_var[0] = vp3_var[0] + .004*(double)(delx);
      if(A1D)  vp3_var[1] = vp3_var[1] + .01*(double)(delx);
      if(LLE)  vp3_var[6] = vp3_var[6] + .008*(double)(delx);
      if(LRI)  vp3_var[7] = vp3_var[7] + .008*(double)(delx);
      if(PHM)  vp4_var[1] = vp4_var[1] + .008*(double)(delx);
      if(PS2)  vp4_var[3] = vp4_var[3] + .008*(double)(delx);
      if(STP)  vp4_var[5] = vp4_var[5] + (delx)/8.;
      break;
    case three_ind_rp:
      break;
    case three_ind_pr:
      break;
    case three_ind_pp:
      break;
    case four_osc_rr:
      break;
    case four_osc_rp:
      break;
    case four_osc_pr:
      break;
    case four_osc_pp:
      break;
    case four_ind_rr:
      if(D1D)  vp3_var[0] = vp3_var[0] + .004*(double)(delx);
      if(A1D)  vp3_var[1] = vp3_var[1] + .02*(double)(delx);
      if(D3D)  vp3_var[2] = vp3_var[2] + .0004*(double)(delx);
      if(A3D)  vp3_var[3] = vp3_var[3] + .0002*(double)(delx);
      if(D4D)  k1 = k1 + .004*(double)(delx);
      if(A4D)  k2 = k2 + .02*(double)(delx);
      if(LLE)  vp3_var[6] = vp3_var[6] + .008*(double)(delx);
      if(LRI)  vp3_var[7] = vp3_var[7] + .008*(double)(delx);
      if(DPH)  vp4_var[0] = vp4_var[0] + .008*(double)(delx);
      if(PHM)  vp4_var[1] = vp4_var[1] + .008*(double)(delx);
      if(PS1)  vp4_var[2] = vp4_var[2] + .008*(double)(delx);
      if(PS2)  vp4_var[3] = vp4_var[3] + .008*(double)(delx);
      if(PS3)  vp4_var[4] = vp4_var[4] + .008*(double)(delx);
      if(STP)  vp4_var[5] = vp4_var[5] + (delx)/8.;
      break;
    case four_ind_rp:
      break;
    case four_ind_pr:
      break;
    case four_ind_pp:
      break;
    }
}

